#line 1 "C:/Users/user/Documents/Education/Publication/DS3321-RTC/DS3231 RTC.c"
#line 1 "c:/users/user/documents/education/publication/ds3321-rtc/ds3231.h"
#line 31 "c:/users/user/documents/education/publication/ds3321-rtc/ds3231.h"
enum days_of_week{SUN = 1, MON, TUE, WED, THU, FRI, SAT};


unsigned char bcd_to_decimal(unsigned char d);
unsigned char decimal_to_bcd(unsigned char d);
unsigned char DS3231_Read(unsigned char address);
void DS3231_Write(unsigned char address, unsigned char value);
void DS3231_init();
void getTime(unsigned char *hour, unsigned char *minute, unsigned char *second, short *am_pm, short hour_format);
void getDate(unsigned char *day_of_week, unsigned char *date, unsigned char *month, unsigned char *year);
void setTime(unsigned char hSet, unsigned char mSet, unsigned char sSet, short am_pm_state, short hour_format);
void setDate(unsigned char daySet, unsigned char dateSet, unsigned char monthSet, unsigned char yearSet);
float getTemp();
#line 8 "C:/Users/user/Documents/Education/Publication/DS3321-RTC/DS3231 RTC.c"
sbit LCD_RS at RC1_bit;
sbit LCD_EN at RC0_bit;
sbit LCD_D4 at RA4_bit;
sbit LCD_D5 at RA5_bit;
sbit LCD_D6 at RA6_bit;
sbit LCD_D7 at RA7_bit;


sbit LCD_RS_Direction at TRISC1_bit;
sbit LCD_EN_Direction at TRISC0_bit;
sbit LCD_D4_Direction at TRISA4_bit;
sbit LCD_D5_Direction at TRISA5_bit;
sbit LCD_D6_Direction at TRISA6_bit;
sbit LCD_D7_Direction at TRISA7_bit;




char txt_buffer[7], cursor = 1;
char rtc_hour, rtc_minute, rtc_second, rtc_ampm, rtc_dow, rtc_date, rtc_month, rtc_year;
char prev_minute = 0;

char set_hour, set_minute, set_ampm, set_day, set_dow, set_event_desc[8], set_recipient_phone[16];
char recipient_eeprom_address, recipient_phone[16], event_desc[8];
short rtc_hour_format;


char txt[3];
unsigned short kp, cnt, oldstate = 0;
char tmp, no_of_zeros;
char chr;
unsigned int temp_conv;
char intro_msg[] = "REAL TIME CLOCK AND CALENDER WITH TEMP.";

char temp_str[8], disp_result,g;
void format_reminder_sms(char* sms_msg, char* sms_event_desc);


void initialize_LCD(){
  TRISC2_bit  = 0;
  LATC2_bit  = 1;
 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Delay_ms(200);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Delay_ms(200);
 Lcd_Out(1,1, intro_msg);
 Delay_ms(1500);
 for(g=0; g<sizeof(intro_msg)-16; g++) {
 Lcd_Cmd(_LCD_SHIFT_LEFT);
 Delay_ms(700);
 }


}
void format_time(int value, char* result, char zeros){

 IntToStr(value, result);
 strcpy(result , Rtrim(result));
 strcpy(result , Ltrim(result));
 if(zeros>0)
 {
 *(result+1) = *(result);
 *(result)='0';
 *(result+2) = 0;

 }
}

char* day_of_week_int2str(char day_of_week){
 char lcd_DOW[4];
 switch(day_of_week){
 case 1:{
 strcpy(lcd_DOW, "SUN");
 break;
 }
 case 2:{
 strcpy(lcd_DOW, "MON");
 break;
 }
 case 3:{
 strcpy(lcd_DOW, "TUE");
 break;
 }
 case 4:{
 strcpy(lcd_DOW, "WED");
 break;
 }
 case 5:{
 strcpy(lcd_DOW, "THU");
 break;
 }
 case 6:{
 strcpy(lcd_DOW, "FRI");
 break;
 }
 case 7:{
 strcpy(lcd_DOW, "SUN");
 break;
 }
 return lcd_DOW;
 }
}
void main() {


 TRISA = 0;




 IRCF2_bit = 1;
 IRCF1_bit = 1;
 IRCF0_bit = 1;

 Delay_ms(1000);
 ADCON1 = 0XFF;


 initialize_LCD();


 DS3231_init();
 setTime(7,51,0, 0 , 1 );
 setDate(SUN,3,4,14);



 while(1){


 Lcd_Cmd(_LCD_CLEAR);

 getDate(&rtc_dow, &rtc_date, &rtc_month, &rtc_year);
 getTime(&rtc_hour, &rtc_minute, &rtc_second, &rtc_ampm,  1 );



 Lcd_Out(1,1,day_of_week_int2str(rtc_dow));
 Lcd_Out_CP(" ");


 temp_conv = rtc_hour;
 format_time(temp_conv, txt_buffer,0);
 Lcd_Out_CP(txt_buffer);

 Lcd_Out_CP(":");
 temp_conv = rtc_minute;
 if(rtc_minute < 10)
 no_of_zeros = 1;
 else
 no_of_zeros = 0;
 format_time(temp_conv, txt_buffer, no_of_zeros);
 Lcd_Out_CP(txt_buffer);
#line 176 "C:/Users/user/Documents/Education/Publication/DS3321-RTC/DS3231 RTC.c"
 if(rtc_ampm)
 Lcd_Out_CP("PM");
 else
 Lcd_Out_CP("AM");




 temp_conv = rtc_date;
 format_time(temp_conv, txt_buffer,0);
 Lcd_Out(2,4,txt_buffer);

 Lcd_Chr_CP('/');

 temp_conv = rtc_month;
 format_time(temp_conv, txt_buffer,0);
 Lcd_Out_CP(txt_buffer);

 Lcd_Chr_CP('/');


 temp_conv = rtc_year;
 format_time(temp_conv, txt_buffer,0);
 Lcd_Out_CP(txt_buffer);


 Delay_ms(900);


 }



}
